// ==============================================================
//                 ORBITER MODULE: WarpMFD
//
//              Copyright (C) 2004 J.J. Luna
//                   All rights reserved
//
// WarpMFD.h 
//
// See WarpMFDreadme.txt
//
// ==============================================================

#ifndef __MFDWARP_H
#define __MFDWARP_H

#define NAME_SIZE 100

class MFDWarp: public MFD {
public:

	/*
		The public interface should be only these four functions:
	*/
	bool selectTarget(char *name, bool doCalcs);
	bool setDist(char *s); // Specify the distance with prefixes %, K, M or G
	void setVel(double v); // km/s	
	void doWarp(void); // A selectTarget() call must be done before calling doWarp()

	
	// Warp parameters
	OBJHANDLE target;
	char targetName[NAME_SIZE];
	VECTOR3 targetRelPos, targetRelVel;
	double targetRadius, targetDistance, targetVelocity;
	double userDistance, userVelocity;

	// Warp engine
	VECTOR3 focusPos, focusDir, warpPos, warpVel;
	double warpDist;
	OBJHANDLE dummy; // Dummy object for the warp translation
	double probFailure; // Prob. of bad warp
	ATTACHMENTHANDLE attachDummy;	// Tochild attach of dummy object
	VESSEL *dummyInt, *focus;
	bool warpCleanup;
	double cleanupTime;
	bool success, calcsDone;
	
	char debugString[100];
	
	MFDWarp (DWORD w, DWORD h, VESSEL *vessel);
	~MFDWarp ();
	char *ButtonLabel (int bt);
	int ButtonMenu (const MFDBUTTONMENU **menu) const;
	bool ConsumeButton (int bt, int event);
	bool ConsumeKeyBuffered(DWORD key);
	void Update (HDC hDC);
	static int MsgProc (UINT msg, UINT mfd, WPARAM wparam, LPARAM lparam);
	bool calculateWarpPos(void);


};

#endif // !__MFDWARP_H